#property copyright "MA-Lite-Edition 2016.01.05"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_width1 1
#property indicator_color2 FireBrick
#property indicator_width2 1

extern int    Length   =      68;
extern int    MaxBars  =    1000;
extern double Cycle    =       4;

bool up; int Phase; double Coeff, Len, pi = 3.1415926535, old, cur, UpBuffer[], DnBuffer[];

int init()
 {
  Coeff = 3 * pi; Phase = Length - 1; Len = Length * Cycle + Phase;
  SetIndexStyle(0, DRAW_ARROW); SetIndexBuffer(0, UpBuffer); SetIndexArrow(0, 159);
  SetIndexStyle(1, DRAW_ARROW); SetIndexBuffer(1, DnBuffer); SetIndexArrow(1, 159);
 }

int start()
 {
  double alfa, t, Sum, Weight, g; int i, shift;
  for (shift = MathMin(Bars - 1 - IndicatorCounted(), MaxBars); shift >= 1; shift--)
   {
    Weight = 0; Sum = 0; t = 0;
    for (i = 0; i <= Len - 1; i++)
     {
      g = 1.0 / (Coeff * t + 1); if (t <= 0.5) g = 1;
      alfa = g * MathCos(pi * t); Sum += alfa * Close[shift + i]; Weight += alfa;
      if (t < 1) t += 1.0 / (Phase - 1);
      else if (t < Len - 1) t += (2 * Cycle - 1) / (Cycle * Length - 1);
     }
    if (Weight != 0) cur = Sum / Weight;
    double dir = cur - old; old = cur;
    if (dir > 0) up = true;
    if (dir < 0) up = false;
    if (up) UpBuffer[shift] = cur;
    else DnBuffer[shift] = cur;
   }
 }

